Upstream-Status: Pending
From 86f605dc9bdfea14836be2832813e845f9d1bfcc Mon Sep 17 00:00:00 2001
From: Nava kishore Manne <nava.manne@xilinx.com>
Date: Thu, 27 Jan 2022 11:18:46 +0530
Subject: [PATCH 075/295] fpga: region: Update runtime PM handling logic

If FPGA has already been configured prior to OS boot up and the user
enables the pl power domain in the base dtb. In this use case we need
to handle the PL power up properly otherwise, the PL related functionality
will not work as expected after OS boot-up.

To fix this issue update the runtime PM handling logic to keep the PL Power
domain on at boot time and the PL power domain will be turned on before
loading the bitstream, turned off while removing/unloading the bitstream
using overlays.

Signed-off-by: Nava kishore Manne <nava.manne@xilinx.com>
State: pending
---
 drivers/fpga/of-fpga-region.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

diff --git a/drivers/fpga/of-fpga-region.c b/drivers/fpga/of-fpga-region.c
index 405cf843a68a..77739ff39b5a 100644
--- a/drivers/fpga/of-fpga-region.c
+++ b/drivers/fpga/of-fpga-region.c
@@ -313,6 +313,8 @@ static int of_fpga_region_notify_pre_apply(struct fpga_region *region,
 	}
 
 	region->info = info;
+	pm_runtime_put_sync(dev->parent);
+	pm_runtime_barrier(dev->parent);
 	pm_runtime_get_sync(dev->parent);
 	ret = fpga_region_program_fpga(region);
 	if (ret) {
@@ -425,8 +427,6 @@ static int of_fpga_region_probe(struct platform_device *pdev)
 	if (ret < 0)
 		goto err_pm;
 
-	pm_runtime_put(&pdev->dev);
-
 	region = fpga_region_register(dev, mgr, of_fpga_region_get_bridges);
 	if (IS_ERR(region)) {
 		ret = PTR_ERR(region);
-- 
2.34.1

